<?php

namespace Teknisa\FIS\Factories;

use Doctrine\ORM\EntityManager;

class Fis07200LivroMagneticoFactory {
    
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function deletaLayoutCFOPLivroMag($params, $apagaLivroMag = false ){
        $sql = "DELETE FROM CFOPLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "DELETE FROM CFOPLIVROMAGTPOP WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "DELETE FROM LAYOUTLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "DELETE FROM TPOPERLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        if( $apagaLivroMag ) {
            $sql = "DELETE FROM RELACPRODITGEN WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
            $sql = "DELETE FROM TIPOITEMPROD WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
            $sql = "DELETE FROM LIVROMAGNETICO WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        }
    }
     public function deletaCadastroTipo($params){
        $sql = "DELETE FROM CFOPLIVROMAGTPOP WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "DELETE FROM TPOPERLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
     public function deletaCadastroLayout($params){
        $sql = "DELETE FROM CFOPLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $sql = "DELETE FROM LAYOUTLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deletaTipoDocumentoCfopLayout($params){
        $sql = "DELETE FROM CFOPLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG AND CDLAYOUTLMAG = :CDLAYOUTLMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
     public function deletaTipoDocumentoCfopTipo($params){
        $sql = "DELETE FROM CFOPLIVROMAGTPOP WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG AND IDENTRSAIDOP = :IDENTRSAIDOP AND CDTIPOOPER = :CDTIPOOPER";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
     
    public function replicaTipoDocumentoCFOP($params){
        $sql = "INSERT INTO LAYOUTLIVROMAG(NRORG, CDLIVROMAG, CDLAYOUTLMAG, NMLAYOUTLMAG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO) (SELECT NRORG, :CDLIVROMAGDEST, CDLAYOUTLMAG, NMLAYOUTLMAG, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S' FROM LAYOUTLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAGORIG)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "INSERT INTO CFOPLIVROMAG(NRORG, CDLIVROMAG, CDLAYOUTLMAG, CDCFOPLMAG, DSCFOPLMAG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO) (SELECT NRORG, :CDLIVROMAGDEST, CDLAYOUTLMAG, CDCFOPLMAG, DSCFOPLMAG, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S' FROM CFOPLIVROMAG WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAGORIG)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    public function replicaCadastroTipo($params){
        $sql = "INSERT INTO TPOPERLIVROMAG ( NRORG, CDLIVROMAG, IDENTRSAIDOP, CDTIPOOPER, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO ) (SELECT NRORG, :CDLIVROMAGDEST, IDENTRSAIDOP, CDTIPOOPER, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S' FROM TPOPERLIVROMAG WHERE NRORG    = :NRORG AND CDLIVROMAG = :CDLIVROMAGORIG )";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "INSERT INTO CFOPLIVROMAGTPOP ( NRORG, CDLIVROMAG, IDENTRSAIDOP, CDTIPOOPER, CDCFOPLMAG, DSCFOPLMAG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO ) (SELECT NRORG, :CDLIVROMAGDEST, IDENTRSAIDOP, CDTIPOOPER, CDCFOPLMAG, DSCFOPLMAG, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S' FROM CFOPLIVROMAGTPOP WHERE NRORG    = :NRORG AND CDLIVROMAG = :CDLIVROMAGORIG )";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveLayoutLivroMag($params){
        $sql = "INSERT INTO LAYOUTLIVROMAG (NRORG, CDLIVROMAG, CDLAYOUTLMAG, NMLAYOUTLMAG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO) VALUES (:NRORG, :CDLIVROMAG, :CDLAYOUTLMAG, :NMLAYOUTLMAG, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S')";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveCFOPLayoutLivroMag($params){
        $sql = "INSERT INTO CFOPLIVROMAG(NRORG, CDLIVROMAG, CDLAYOUTLMAG, CDCFOPLMAG, DSCFOPLMAG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO) VALUES (:NRORG, :CDLIVROMAG, :CDLAYOUTLMAG, :CDCFOPLMAG, :DSCFOPLMAG, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S')";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function deletaGeneroItemProduto($params){
        $sql = "DELETE FROM RELACPRODITGEN WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "DELETE FROM TIPOITEMPROD WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function replicaGeneroTipoItemProduto($params){
        $sql = "INSERT INTO TIPOITEMPROD(NRORG, CDLIVROMAG, CDTPITEMPROD, NMTPITEMPROD, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO) (SELECT NRORG, :CDLIVROMAGDEST, CDTPITEMPROD, NMTPITEMPROD, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S' FROM TIPOITEMPROD WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAGORIG)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        //Adiquiri os ...
        $sql = "SELECT NRORG, :CDLIVROMAGDEST, CDPRODUTO, CDTPITEMPROD, CDGENPROD, CDNATUREC, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S' FROM RELACPRODITGEN WHERE NRORG    = :NRORG AND CDLIVROMAG = :CDLIVROMAGORIG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        $result = $std->fetchAll();
        
        $sql = "INSERT INTO RELACPRODITGEN ( NRORG, CDLIVROMAG, CDPRODUTO, CDTPITEMPROD, CDGENPROD, CDNATUREC, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO ) VALUES (:NRORG, :CDLIVROMAG, :CDPRODUTO, :CDTPITEMPROD, :CDGENPROD, :CDNATUREC, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, :IDATIVO)";
        
        foreach( $result as $val ) {
            //Verificar se existe ...
            $generoProd = $this->getGeneroProd( $params['NRORG'], $val['CDGENPROD'], $val[':CDLIVROMAGDEST'] );
            if( !$generoProd ) {
                $generoProd = $this->getGeneroProd( $params['NRORG'], $val['CDGENPROD'], 'MOBILE' );
                $this->insertGeneroProd( $val['CDGENPROD'], $generoProd['DSGENPROD'], $val[':CDLIVROMAGDEST'], $params['NRORG'], $params['CDOPERINCLUSAO'] );
            }
            $p = array( "NRORG"          => $val['NRORG'],
                        "CDLIVROMAG"     => $val[':CDLIVROMAGDEST'],
                        "CDPRODUTO"      => $val['CDPRODUTO'],
                        "CDTPITEMPROD"   => $val['CDTPITEMPROD'],
                        "CDGENPROD"      => $val['CDGENPROD'],
                        "CDNATUREC"      => $val['CDNATUREC'],
                        "DTINCLUSAO"     => $val[':DTINCLUSAO'],
                        "NRORGINCLUSAO"  => $val[':NRORGINCLUSAO'],
                        "CDOPERINCLUSAO" => $val[':CDOPERINCLUSAO'],
                        "IDATIVO"        => 'S');
            //Faz a inserção do ...
            $std = $this->connection->prepare( $sql );
            $std->execute( $p );
        }
    }
    public function getIntervaloProdutos($nrorg,$cdprodini,$cdprodfin){
      $params =  array( 'NRORG'     => $nrorg,
                        'CDPRODINI' => $cdprodini,
                        "CDPRODFIN" => $cdprodfin);
                        
        $sql = "SELECT CDPRODUTO FROM PRODUTO WHERE NRORG = :NRORG AND CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIN AND CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO WHERE NRORG = :NRORG)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getGenItemProduto($params){
        $sql = "SELECT * FROM RELACPRODITGEN WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG AND CDPRODUTO = :CDPRODUTO";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function insertRelacProdItGen($params){
        $sql = "INSERT INTO RELACPRODITGEN(NRORG, CDLIVROMAG, CDPRODUTO, CDGENPROD, CDTPITEMPROD, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO) VALUES (:NRORG, :CDLIVROMAG, :CDPRODUTO, :CDGENPROD, :CDTPITEMPROD, :DTINCLUSAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, 'S')";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateRelacProdItGen($params){
        $sql = "UPDATE RELACPRODITGEN SET CDGENPROD = :CDGENPROD, CDTPITEMPROD = :CDTPITEMPROD, DTULTATU = :DTULTATU, NRORGULTATU = :NRORGULTATU, CDOPERULTATU = :CDOPERULTATU WHERE NRORG = :NRORG AND CDLIVROMAG = :CDLIVROMAG AND CDPRODUTO = :CDPRODUTO";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insertGeneroProd( $cdgenprod, $dsgenprod, $cdlivromag, $nrorg, $cdoperinclusao ) {
        $params = array( 'NRORG'     => $nrorg,
                         'CDGENPROD' => $cdgenprod,
                         'DSGENPROD' => $dsgenprod,
                         'CDLIVROMAG' => $cdlivromag,
                         'CDOPERINCLUSAO' => $cdoperinclusao );
                         
        $sql = "INSERT INTO GENEROPROD (CDGENPROD, DSGENPROD, CDLIVROMAG, NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO) VALUES (:CDGENPROD, :DSGENPROD, :CDLIVROMAG, :NRORG, 'S', SYSDATE, :NRORG, :CDOPERINCLUSAO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getGeneroProd( $nrorg, $cdgenprod, $cdlivromag ) {
        $params = array( 'NRORG'     => $nrorg,
                         'CDGENPROD' => $cdgenprod,
                         'CDLIVROMAG' => $cdlivromag);
        $sql = "SELECT * FROM GENEROPROD WHERE NRORG = :NRORG AND CDGENPROD = :CDGENPROD AND CDLIVROMAG = :CDLIVROMAG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    
};