<?php
namespace Teknisa\FIS\Modules\Acessorias\Factories;

use Doctrine\ORM\EntityManager;

class Fis91000ObrigacoesAcessoriasFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        set_time_limit(0);
    }

    /*
     * Função para retornar o mapa de apuração não bloqueado dada uma empresa
     * para os impostos "50", "55", "60" e "65".
     */
    public function getMapaapurac($params) {
        // Query a ser executada.
        $sql = "SELECT NRSEQUMAPAPU FROM MAPAAPURAC MP WHERE (INSTR(:IMPOSTOS, MP.CDIMPOSTO) > 0) AND MP.CDEMPRESA = :CDEMPRESA AND MP.CDINSCESTA = NVL(:CDINSCESTA, MP.CDINSCESTA) AND MP.NRORG = :NRORG AND MP.DTFIMPERIODO >= TO_DATE(:DTINICIAL, 'DD/MM/YYYY') AND MP.DTINIPERIODO <= TO_DATE(:DTFINAL, 'DD/MM/YYYY') AND NVL(MP.IDBLOQMAPAPU,'A') <> 'S'";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetch(\PDO::FETCH_ASSOC);
    }

    /*
     * Função para retornar os "Parâmetros de Fiscal" de uma organização.
     */
    public function getParamfiscal($params) {
        // Query a ser executada.
        $sql = "SELECT * FROM PARAMFISCAL WHERE NRORG = :NRORG";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetch(\PDO::FETCH_ASSOC);
    }
}